package demo.linksprite.mybluetoothwatch.app;

import android.app.Application;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.ServiceConnection;
import android.os.IBinder;
import android.util.Log;

import demo.linksprite.mybluetoothwatch.ble.BleBaseService;


/**
 * Created by Administrator on 2016/1/20.
 */
public class App extends Application {
    private BleBaseService mService;

    private ServiceConnection mServiceConnection = new ServiceConnection() {
        @Override
        public void onServiceConnected(ComponentName name, IBinder service) {
            mService = ((BleBaseService.LocalBind) service).getService();
            if (mService == null || !mService.initBleService()) {
                mService.stopSelf();
                mService = null;
            } else
                Log.e("App", "蓝牙初始化成功");
        }

        @Override
        public void onServiceDisconnected(ComponentName name) {
            mService = null;
        }
    };

    @Override
    public void onCreate() {
        super.onCreate();
        Intent bindIntent = new Intent(this, BleBaseService.class);
        bindService(bindIntent, mServiceConnection, Context.BIND_AUTO_CREATE);
    }

    public BleBaseService getService() {
        return mService;
    }
}
