package demo.linksprite.mybluetoothwatch.ble;

import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothGatt;
import android.bluetooth.BluetoothGattCharacteristic;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.HandlerThread;
import android.os.Message;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;

import demo.linksprite.mybluetoothwatch.app.App;


/**
 * Created by zsq on 2016/1/21.
 */
public abstract class BaseActivity extends AppCompatActivity implements BleCallBack {
    private final static String TAG = BaseActivity.class.getName();
    private final static int ENABLE_BT = 1;
    public BleBaseService mService;
    private App app;
    public Handler handler;
    private HandlerThread handlerThread = new HandlerThread("LinkSpriteBaseActivity");
    private Handler mServiceHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            Log.d(TAG, "recieve a msg");
            switch (msg.what) {
                case 1:
                    mService = app.getService();
                    if (mService == null)
                        mServiceHandler.sendEmptyMessageDelayed(1, 1000);
                    else {
                        mService.setBleCallBack(BaseActivity.this);
                        Log.d(TAG, "serviceReady");
                        serviceReady();
                    }
                    break;
                case 2:
                    break;
            }
        }
    };


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        onCreateBeforeDo(savedInstanceState);
        super.onCreate(savedInstanceState);
        initView();
        app = (App) getApplication();
        handlerThread.start();
        handler = new Handler(handlerThread.getLooper(), getCallBack());
        mServiceHandler.sendEmptyMessage(1);
    }

    public abstract void serviceReady();

    public abstract void onCreateBeforeDo(Bundle savedInstanceState);

    public abstract Handler.Callback getCallBack();

    public abstract void initView();

    private void OpenBluetooth() {
        Intent enableIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
        startActivityForResult(enableIntent, ENABLE_BT);
    }

    @Override
    public void disOpenBluetooth() {
        OpenBluetooth();
    }

    @Override
    public abstract void onDeviceConnected();

    @Override
    public abstract void onDeviceReady();

    @Override
    public abstract void onDeviceDisconnecting();

    @Override
    public abstract void onDeviceDisconnected();

    @Override
    public abstract void onLinklossOccur();

    @Override
    public void onBondingRequired() {

    }

    @Override
    public void onBonded() {

    }

    @Override
    public void onDeviceNotSupported() {

    }

    @Override
    public void onReadData(BluetoothGatt gatt, BluetoothGattCharacteristic characteristic) {

    }

    @Override
    public void onError(int status, String msg) {

    }

    @Override
    public void onReadRssi(int rssi) {

    }


    public void onDeviceFound(BluetoothDevice device, int rssi) {
    }

    @Override
    public void onDeviceNotFound() {

    }

    public abstract void BluetoothOpened();

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        switch (requestCode) {
            case ENABLE_BT:
                // When the request to enable Bluetooth returns
                if (resultCode == Activity.RESULT_OK) {
                    BluetoothOpened();
                }
                break;
        }
    }

    public void removeHandler() {
        handler.removeCallbacksAndMessages(null);
    }

    public abstract void onDataSendOver();
}
