package demo.linksprite.mybluetoothwatch.ble;

import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothGatt;
import android.bluetooth.BluetoothGattCallback;
import android.bluetooth.BluetoothGattCharacteristic;

/**
 * Created by Administrator on 2016/1/19.
 *
 */
public interface BleCallBack {


    public void disOpenBluetooth();

    /**
     * Called when the device has been connected. This does not mean that the application may start communication. A service discovery will be handled automatically after this call. Service discovery
     * may ends up with calling {@link #onDeviceReady()} or {@link #onDeviceNotSupported()} if required services have not been found.
     */
    public void onDeviceConnected();

    /**
     * Method called when all initialization requests has been completed.
     */
    public void onDeviceReady();

    /**
     * Called when user initialized disconnection.
     */
    public void onDeviceDisconnecting();

    /**
     * Called when the device has disconnected (when the callback returned {@link BluetoothGattCallback#onConnectionStateChange(BluetoothGatt, int, int)} with state DISCONNECTED.
     */
    public void onDeviceDisconnected();

    /**
     * This callback is invoked when the Ble Manager lost connection to a device that has been connected with autoConnect option. Otherwise a {@link #onDeviceDisconnected()}
     * method will be called on such event.
     */
    public void onLinklossOccur();

    /**
     * Called when an {@link BluetoothGatt#GATT_INSUFFICIENT_AUTHENTICATION} error occurred and the device bond state is NOT_BONDED
     */
    public void onBondingRequired();

    /**
     * Called when the device has been successfully bonded.
     */
    public void onBonded();

    /**
     * Called when service discovery has finished but the main services were not found on the device.
     */
    public void onDeviceNotSupported();

    public  void onReadData(BluetoothGatt gatt, BluetoothGattCharacteristic characteristic);

    public  void onError(int status, String msg);

    public  void onReadRssi(int rssi);

    public void onDeviceFound(BluetoothDevice device, int rssi, byte[] scanRecord);

    public void onDeviceNotFound();

    public void onDiscoverServer();

    public void onTimeOut(int staus);

    public void onDataSendOver();
}
